// Implementation ConfigLed
//
// Copyright Matthias Gaertner, Schenefeld, Germany, 2001
// You may use this code under the terms of the GPL.
// Updated packages may be found at http://www.rtner.de/parsled/
//

#include <ConfigLed.h>


ConfigLed::ConfigLed() :
    ParSledConfigClass("LED"),
    _name(""),
    _mode(0),
    _dutyCycleOn( 1 ),
    _dutyCycleOff( 1 ),
    _physical( 0 ),
    _cycle( 0 ),
    _flashnumber( 0 )
{
}

ConfigLed::~ConfigLed()
{
}

// 0: OK else error
int ConfigLed::feedLine( IConfigLine *icf )
{
    int r = 0;
    if( (r=icf->scanNonEmptyString( "NAME", &_name )) >= 0 )
    {
        return r;
    }
    if( icf->getToken().equals("MODE") )
    {
        if( icf->getData().equals("BLINK") )
        {
            _mode = 0;
        }
        else if( icf->getData().equals("ON") )
        {
            _mode = 1;
        }
        else if( icf->getData().equals("OFF") )
        {
            _mode = 2;
        }
        else if( icf->getData().equals("BUTTON") )
        {
            _mode = 3;
        }
        else if( icf->getData().equals("COMMAND") )
        {
            _mode = 4;
        }
        else if( icf->getData().equals("RUNLEVEL") )
        {
            _mode = 5;
        }
        return 0;
    }
    if( (r=icf->scanPositiveInt( "DUTY_CYCLE_ON", &_dutyCycleOn )) >= 0 )
    {
        return r;
    }
    if( (r=icf->scanPositiveInt( "DUTY_CYCLE_OFF", &_dutyCycleOff )) >= 0 )
    {
        return r;
    }
    if( (r=icf->scanNonNegativeInt( "PHYSICAL", &_physical )) >= 0 )
    {
        return r;
    }
    return 1;
}

// 0: OK else error
int ConfigLed::checkOK()
{
    return 0;
}

int ConfigLed::getMode( void )
{
    return _mode;
}

unsigned int ConfigLed::getDutyCycleOn( void )
{
    return _dutyCycleOn;
}

unsigned int ConfigLed::getDutyCycleOff( void )
{
    return _dutyCycleOff;
}

unsigned int ConfigLed::getPhysical( void )
{
    return _physical;
}

unsigned int ConfigLed::getCycle( void )
{
    return _cycle;
}

void ConfigLed::setCycle( unsigned int n )
{
    _cycle = n;
}

int ConfigLed::getFlashNumber( void )
{
    return _flashnumber;
}

void ConfigLed::setFlashNumber( int n )
{
    _flashnumber = n;
}

/* */
