// Implementation for ParSledConfigClass
//
// Copyright Matthias Gaertner, Schenefeld, Germany, 2001
// You may use this code under the terms of the GPL.
// Updated packages may be found at http://www.rtner.de/parsled/
//

#include <stdio.h>
#include <ParSledConfigClass.h>


ConfigClassListElement::ConfigClassListElement() :
    _next( NULL ),
    _c( NULL )
{
}

ConfigClassListElement::~ConfigClassListElement()
{
    delete _c;
}

//---

ParSledConfigClass::ParSledConfigClass() :
    _classname( "" ),
    _l( NULL ),
    _cursor( NULL )
{
}

ParSledConfigClass::ParSledConfigClass( const char *name ) :
    _classname( name ),
    _l( NULL ),
    _cursor( NULL )
{
}

ParSledConfigClass::~ParSledConfigClass()
{
    struct ConfigClassListElement *p = _l;
    while( p != NULL )
    {
        struct ConfigClassListElement *q = p->_next;
        delete p;
        p = q;
    }
}

const SimpleString &ParSledConfigClass::getClassName( void ) const
{
    return _classname;
}

void ParSledConfigClass::addSubelement( IConfigClass *c )
{
    struct ConfigClassListElement **pp = &_l;
    while( *pp != NULL )
    {
        pp = &(*pp)->_next;
    }

    *pp = new struct ConfigClassListElement;
    (*pp)->_c = c;
}

void ParSledConfigClass::resetIter( void )
{
    _cursor = _l;
}

IConfigClass *ParSledConfigClass::getNextIter( void )
{
    if( _cursor == NULL )
    {
        return NULL;
    }
    IConfigClass *r = _cursor->_c;
    _cursor = _cursor->_next;
    return r;
}

/* */
